searchNodes=[{"ref":"Rajska.html","title":"Rajska","type":"module","doc":"Rajska is an elixir authorization library for Absinthe. It provides the following middlewares: Rajska.QueryAuthorization Rajska.QueryScopeAuthorization Rajska.ObjectAuthorization Rajska.ObjectScopeAuthorization Rajska.FieldAuthorization Installation The package can be installed by adding rajska to your list of dependencies in mix.exs: def deps do [ {:rajska, &quot;~&gt; 0.1.0&quot;}, ] end Usage Create your Authorization module, which will implement the Rajska.Authorization behaviour and contain the logic to validate user permissions and will be called by Rajska middlewares. Rajska provides some helper functions by default, such as Rajska.Authorization.is_role_authorized?/2, Rajska.Authorization.has_user_access?/3 and Rajska.Authorization.is_field_authorized?/3, but you can override them with your application needs. defmodule Authorization do use Rajska, roles: [:user, :admin] end Note: if you pass a non Keyword list to roles, as above, Rajska will assume your roles are in ascending order and the last one is the super role. You can override this behavior by defining your own Rajska.Authorization.is_super_role?/1 function or passing a Keyword list in the format [user: 0, admin: 1]. Add your Authorization module to your Absinthe.Schema context/1 callback and the desired middlewares to the middleware/3 callback: def context(ctx), do: Map.put(ctx, :authorization, Authorization) def middleware(middleware, field, %Absinthe.Type.Object{identifier: identifier}) when identifier in [:query, :mutation, :subscription] do middleware |&gt; Rajska.add_query_authorization(field, Authorization) |&gt; Rajska.add_object_authorization() end def middleware(middleware, field, object) do Rajska.add_field_authorization(middleware, field, object) end Since Scope Authorization middleware must be used with Query Authorization, it is automatically called when adding the former."},{"ref":"Rajska.html#add_field_authorization/3","title":"Rajska.add_field_authorization/3","type":"function","doc":"See Rajska.Schema.add_field_authorization/3."},{"ref":"Rajska.html#add_object_authorization/1","title":"Rajska.add_object_authorization/1","type":"function","doc":"See Rajska.Schema.add_object_authorization/1."},{"ref":"Rajska.html#add_query_authorization/3","title":"Rajska.add_query_authorization/3","type":"function","doc":"See Rajska.Schema.add_query_authorization/3."},{"ref":"Rajska.Authorization.html","title":"Rajska.Authorization","type":"behaviour","doc":"Behaviour of an Authorization module."},{"ref":"Rajska.Authorization.html#c:get_current_user/1","title":"Rajska.Authorization.get_current_user/1","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:get_user_role/1","title":"Rajska.Authorization.get_user_role/1","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:has_user_access?/3","title":"Rajska.Authorization.has_user_access?/3","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:is_all_role?/1","title":"Rajska.Authorization.is_all_role?/1","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:is_field_authorized?/3","title":"Rajska.Authorization.is_field_authorized?/3","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:is_role_authorized?/2","title":"Rajska.Authorization.is_role_authorized?/2","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:is_super_role?/1","title":"Rajska.Authorization.is_super_role?/1","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:not_scoped_roles/0","title":"Rajska.Authorization.not_scoped_roles/0","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#c:unauthorized_msg/1","title":"Rajska.Authorization.unauthorized_msg/1","type":"callback","doc":""},{"ref":"Rajska.Authorization.html#t:current_user/0","title":"Rajska.Authorization.current_user/0","type":"type","doc":""},{"ref":"Rajska.Authorization.html#t:current_user_role/0","title":"Rajska.Authorization.current_user_role/0","type":"type","doc":""},{"ref":"Rajska.Authorization.html#t:role/0","title":"Rajska.Authorization.role/0","type":"type","doc":""},{"ref":"Rajska.FieldAuthorization.html","title":"Rajska.FieldAuthorization","type":"module","doc":"Absinthe middleware to ensure field permissions. Authorizes Absinthe&#39;s object field according to the result of the Rajska.Authorization.is_field_authorized?/3 function, which receives the user role, the meta scope_by atom defined in the object schema and the source object that is resolving the field. Usage Create your Authorization module and add it and FieldAuthorization to your Absinthe.Schema. Then add the meta scope_by to an object and meta private to your sensitive fields: object :user do meta :scope_by, :id field :name, :string field :is_email_public, :boolean field :phone, :string, meta: [private: true] field :email, :string, meta: [private: &amp; !&amp;1.is_email_public] end As seen in the example above, a function can also be passed as value to the meta :private key, in order to check if a field is private dynamically, depending of the value of another field."},{"ref":"Rajska.FieldAuthorization.html#call/2","title":"Rajska.FieldAuthorization.call/2","type":"function","doc":"This is the main middleware callback. It receives an %Absinthe.Resolution{} struct and it needs to return an %Absinthe.Resolution{} struct. The second argument will be whatever value was passed to the middleware call that setup the middleware. Callback implementation for Absinthe.Middleware.call/2."},{"ref":"Rajska.ObjectAuthorization.html","title":"Rajska.ObjectAuthorization","type":"module","doc":"Absinthe middleware to ensure object permissions. Authorizes all Absinthe&#39;s objects requested in a query by checking the permission defined in each object meta authorize. Usage Create your Authorization module and add it and QueryAuthorization to your Absinthe.Schema. Then set the permitted role to access an object: object :wallet_balance do meta :authorize, :admin field :total, :integer end object :company do meta :authorize, :user field :name, :string field :wallet_balance, :wallet_balance end object :user do meta :authorize, :all field :email, :string field :company, :company end With the permissions above, a query like the following would only be allowed by an admin user: { userQuery { name email company { name walletBalance { total } } } } Object Authorization middleware runs after Query Authorization middleware (if added) and before the query is resolved by recursively checking the requested objects permissions in the Rajska.Authorization.is_role_authorized?/2 function (which is also used by Query Authorization). It can be overridden by your own implementation."},{"ref":"Rajska.ObjectAuthorization.html#call/2","title":"Rajska.ObjectAuthorization.call/2","type":"function","doc":"This is the main middleware callback. It receives an %Absinthe.Resolution{} struct and it needs to return an %Absinthe.Resolution{} struct. The second argument will be whatever value was passed to the middleware call that setup the middleware. Callback implementation for Absinthe.Middleware.call/2."},{"ref":"Rajska.ObjectScopeAuthorization.html","title":"Rajska.ObjectScopeAuthorization","type":"module","doc":"Absinthe Phase to perform object scoping. Authorizes all Absinthe&#39;s objects requested in a query by checking the value of the field defined in each object meta scope. Usage Create your Authorization module and add it and ObjectScopeAuthorization to your Absinthe Pipeline. Then set the scope of an object: object :user do meta :scope, User # Same as meta :scope, {User, :id} field :id, :integer field :email, :string field :name, :string field :company, :company end object :company do meta :scope, {Company, :user_id} field :id, :integer field :user_id, :integer field :name, :string field :wallet, :wallet end object :wallet do meta :scope, Wallet field :total, :integer end To define custom rules for the scoping, use Rajska.Authorization.has_user_access?/3. For example: defmodule Authorization do use Rajska, roles: [:user, :admin] @impl true def has_user_access?(%{role: :admin}, User, _id), do: true def has_user_access?(%{id: user_id}, User, id) when user_id === id, do: true def has_user_access?(_current_user, User, _id), do: false end Keep in mind that the field_value provided to has_user_access?/3 can be nil. This case can be handled as you wish. For example, to not raise any authorization errors and just return nil: defmodule Authorization do use Rajska, roles: [:user, :admin] @impl true def has_user_access?(_user, _, nil), do: true def has_user_access?(%{role: :admin}, User, _id), do: true def has_user_access?(%{id: user_id}, User, id) when user_id === id, do: true def has_user_access?(_current_user, User, _id), do: false end"},{"ref":"Rajska.ObjectScopeAuthorization.html#flag_invalid/1","title":"Rajska.ObjectScopeAuthorization.flag_invalid/1","type":"function","doc":""},{"ref":"Rajska.ObjectScopeAuthorization.html#flag_invalid/2","title":"Rajska.ObjectScopeAuthorization.flag_invalid/2","type":"function","doc":""},{"ref":"Rajska.ObjectScopeAuthorization.html#inherit_invalid/3","title":"Rajska.ObjectScopeAuthorization.inherit_invalid/3","type":"function","doc":""},{"ref":"Rajska.ObjectScopeAuthorization.html#put_flag/2","title":"Rajska.ObjectScopeAuthorization.put_flag/2","type":"function","doc":""},{"ref":"Rajska.ObjectScopeAuthorization.html#run/2","title":"Rajska.ObjectScopeAuthorization.run/2","type":"function","doc":"Callback implementation for Absinthe.Phase.run/2."},{"ref":"Rajska.QueryAuthorization.html","title":"Rajska.QueryAuthorization","type":"module","doc":"Absinthe middleware to ensure query permissions. Usage Create your Authorization module and add it and QueryAuthorization to your Absinthe.Schema. Then set the permitted role to access a query or mutation: mutation do field :create_user, :user do arg :params, non_null(:user_params) middleware Rajska.QueryAuthorization, permit: :all resolve &amp;AccountsResolver.create_user/2 end field :update_user, :user do arg :id, non_null(:integer) arg :params, non_null(:user_params) middleware Rajska.QueryAuthorization, [permit: :user, scoped: User] # same as {User, :id} resolve &amp;AccountsResolver.update_user/2 end field :delete_user, :user do arg :id, non_null(:integer) middleware Rajska.QueryAuthorization, permit: :admin resolve &amp;AccountsResolver.delete_user/2 end end Query authorization will call Rajska.Authorization.is_role_authorized?/2 to check if the user role is authorized to perform the query."},{"ref":"Rajska.QueryAuthorization.html#call/2","title":"Rajska.QueryAuthorization.call/2","type":"function","doc":"This is the main middleware callback. It receives an %Absinthe.Resolution{} struct and it needs to return an %Absinthe.Resolution{} struct. The second argument will be whatever value was passed to the middleware call that setup the middleware. Callback implementation for Absinthe.Middleware.call/2."},{"ref":"Rajska.QueryScopeAuthorization.html","title":"Rajska.QueryScopeAuthorization","type":"module","doc":"Absinthe middleware to perform query scoping. Usage Create your Authorization module and add it and QueryAuthorization to your Absinthe.Schema. Since Scope Authorization middleware must be used with Query Authorization, it is automatically called when adding the former. Then set the scoped module and argument field: mutation do field :create_user, :user do arg :params, non_null(:user_params) middleware Rajska.QueryAuthorization, permit: :all resolve &amp;AccountsResolver.create_user/2 end field :update_user, :user do arg :id, non_null(:integer) arg :params, non_null(:user_params) middleware Rajska.QueryAuthorization, [permit: :user, scoped: User] # same as {User, :id} resolve &amp;AccountsResolver.update_user/2 end field :delete_user, :user do arg :id, non_null(:integer) middleware Rajska.QueryAuthorization, permit: :admin resolve &amp;AccountsResolver.delete_user/2 end end In the above example, :all and :admin permissions don&#39;t require the :scoped keyword, as defined in the Rajska.Authorization.not_scoped_roles/0 function, but you can modify this behavior by overriding it. Valid values for the :scoped keyword are: false: disables scoping User: a module that will be passed to Rajska.Authorization.has_user_access?/3. It must implement a Rajska.Authorization behaviour and a __schema__(:source) function (used to check if the module is valid in Rajska.Schema.validate_query_auth_config!/2) {User, :id}: where :id is the query argument that will also be passed to Rajska.Authorization.has_user_access?/3 {User, [:params, :id]}: where id is the query argument as above, but it&#39;s not defined directly as an arg for the query. Instead, it&#39;s nested inside the params argument. {User, :user_group_id, :optional}: where user_group_id (it could also be a nested argument) is an optional argument for the query. If it&#39;s present, the scoping will be applied, otherwise no scoping is applied."},{"ref":"Rajska.QueryScopeAuthorization.html#apply_scope_authorization/3","title":"Rajska.QueryScopeAuthorization.apply_scope_authorization/3","type":"function","doc":""},{"ref":"Rajska.QueryScopeAuthorization.html#call/2","title":"Rajska.QueryScopeAuthorization.call/2","type":"function","doc":"This is the main middleware callback. It receives an %Absinthe.Resolution{} struct and it needs to return an %Absinthe.Resolution{} struct. The second argument will be whatever value was passed to the middleware call that setup the middleware. Callback implementation for Absinthe.Middleware.call/2."},{"ref":"Rajska.QueryScopeAuthorization.html#scope_user!/2","title":"Rajska.QueryScopeAuthorization.scope_user!/2","type":"function","doc":""},{"ref":"Rajska.Schema.html","title":"Rajska.Schema","type":"module","doc":"Concatenates Rajska middlewares with Absinthe middlewares and validates Query Authorization configuration."},{"ref":"Rajska.Schema.html#add_field_authorization/3","title":"Rajska.Schema.add_field_authorization/3","type":"function","doc":""},{"ref":"Rajska.Schema.html#add_object_authorization/1","title":"Rajska.Schema.add_object_authorization/1","type":"function","doc":""},{"ref":"Rajska.Schema.html#add_query_authorization/3","title":"Rajska.Schema.add_query_authorization/3","type":"function","doc":""},{"ref":"Rajska.Schema.html#validate_query_auth_config!/2","title":"Rajska.Schema.validate_query_auth_config!/2","type":"function","doc":""}]